﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.IO;

namespace Worthaeufigkeiten
{
    class Program
    {
        static void Main(string[] args)
        {
            Tuple<string, string>[] sonnets = new Tuple<string, string>[] {
                   new Tuple<string, string>("Sonett 1.txt",@"C:\shakespeare"),
                   new Tuple<string, string>("Sonett 2.txt",@"C:\shakespeare"),
                   new Tuple<string, string>("Sonett 3.txt",@"C:\shakespeare"),
                   new Tuple<string, string>("Sonett 4.txt",@"C:\shakespeare") };

            MapReduce<string, string> wordCount = new MapReduce<string, string>(sonnets);
            IEnumerable<Tuple<string, int>> wordCollection;

            wordCount.Map<string, int>((input) =>
            {
                StreamReader sw = new StreamReader(input.Item2 + @"\" + input.Item1);
                string data = sw.ReadToEnd();
                string[] words = data.Split(new[] {' ','.',',',';',':','=','+', '-', '*', ')', '(',
                    '!', '#', '$'});
                Dictionary<string, Tuple<string, int>> rawCount = new Dictionary<string, Tuple<string, int>>();
                foreach (var word in words)
                {
                    Tuple<string, int> value;
                    if (rawCount.TryGetValue(word, out value))
                    {
                        int increment = rawCount[word].Item2 + 1;
                        rawCount[word] = new Tuple<string, int>(word, increment);
                    }
                    else
                    {
                        rawCount.Add(word, new Tuple<string, int>(word, 1));
                    }
                }
                return rawCount.Values;
            },
            (key, value) =>
            {
                if (key.Length < 3)
                {
                    return false;
                }
                else
                {
                    return true;
                }
            },
            out wordCollection);

            IEnumerable<Tuple<string, int>> final = wordCount.Reduce(wordCollection, (key, values) =>
            {
                return values.Sum();
            });

            foreach (var item in final)
            {
                Console.WriteLine("{0} = {1}", item.Item1, item.Item2);
            }
        }

    }



}
