﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Collections.Concurrent;
using System.Threading.Tasks;
using System.Threading;

namespace Beispiel
{
    class Person
    {
        static ConcurrentBag<Person> customerList = new ConcurrentBag<Person>();
        public string Name { get; set; }
        public Person() {customerList.Add(this);}
        public void ShopAndExit(){
            var rand=new Random();
            Thread.SpinWait(rand.Next(int.MaxValue));
            Person cust;
            if (customerList.TryTake(out cust))
            {
                if (cust.GetHashCode() == this.GetHashCode())
                {
                    Console.WriteLine("**** {0}=={1} - identische Objekte ****",
                        cust.Name, this.Name);
                }
            }
        }
    }

    class Program
    {
         static void Main(string[] args)
        {
            Parallel.For(0, 4, (index) =>
            {
                var customer=new Person(){Name="Kunde "+
                    index.ToString()};
                Console.WriteLine("[Thread {0}] {1} betritt den Laden.", 
                    Thread.CurrentThread.ManagedThreadId, customer.Name);
                customer.ShopAndExit();
                Console.WriteLine("[Thread {0}] {1} verlässt den Laden.",
                    Thread.CurrentThread.ManagedThreadId, customer.Name);
            });

            //Console.WriteLine("Zum Beenden die Eingabetaste drücken");
            //Console.ReadLine();
        }
    }
} 