﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Collections.Concurrent;
using System.Threading.Tasks;
using System.Threading;

namespace EffizienterHandler
{
    class Program
    {

        public static BlockingCollection<int> collection = new BlockingCollection<int>();
        public static CancellationTokenSource cs = new CancellationTokenSource();

        public static void Handler()
        {
            Console.WriteLine("[{0}] behandelt und entfernt",
                              DateTime.Now.ToLongTimeString());
        }

        static void Main(string[] args)
        {
            var bounded = new BlockingCollection<int>(new ConcurrentBag<int>(), 10);

            Parallel.Invoke(new Action[] {()=>
                {
                    int value=1000;
                    while(!cs.IsCancellationRequested)
                    {
                        Thread.Sleep(value);
                        collection.Add(++value);
                        Console.WriteLine("[{0}] Element wurde hinzugefügt", 
                                          DateTime.Now.ToLongTimeString());
                        value += 2000;
                    }
                },
                ()=>
                    {
                       int item;
                       while(true)
                       {
                           if(collection.TryTake(out item, 10000))
                           {
                                Handler();
                           }
                           else
                           {
                               // Timeout
                               Console.WriteLine("Timeout. Programm wird beendet");
                               cs.Cancel();
                               break;
                           }
                       }
                    }
            });
            
            //Console.WriteLine("Zum Beenden die Eingabetaste drücken");
            //Console.ReadLine();
        }   
    }
}
